/**
 * GazelleXValidator.java
 *
 * File generated from the XValidationReport1::GazelleXValidator uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.report;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.w3c.dom.Node;
// End of user code

/**
 * Description of the class GazelleXValidator.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "GazelleCrossValidatorDescription", propOrder = { "calledValidator", "linkedValidator", "engineVersion", "assertionManagerUrl" })
@XmlRootElement(name = "GazelleCrossValidator")
public class GazelleCrossValidatorDescription implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@XmlElement(name = "CalledValidator", required = true)
	private CrossValidatorDescription calledValidator;
	@XmlElement(name = "LinkedValidator")
	private List<CrossValidatorDescription> linkedValidator;
	@XmlAttribute(name = "engineVersion")
	private String engineVersion;
	@XmlElement(name = "AssertionManagerUrl")
	private String assertionManagerUrl;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * Return calledValidator.
	 * 
	 * @return calledValidator
	 */
	public CrossValidatorDescription getCalledValidator() {
		return calledValidator;
	}

	/**
	 * Set a value to attribute calledValidator.
	 * 
	 * @param calledValidator
	 *            .
	 */
	public void setCalledValidator(CrossValidatorDescription calledValidator) {
		this.calledValidator = calledValidator;
	}

	/**
	 * Return linkedValidator.
	 * 
	 * @return linkedValidator
	 */
	public List<CrossValidatorDescription> getLinkedValidator() {
		if (linkedValidator == null) {
			linkedValidator = new ArrayList<CrossValidatorDescription>();
		}
		return linkedValidator;
	}

	/**
	 * Set a value to attribute linkedValidator.
	 * 
	 * @param linkedValidator
	 *            .
	 */
	public void setLinkedValidator(List<CrossValidatorDescription> linkedValidator) {
		this.linkedValidator = linkedValidator;
	}

	/**
	 * Add a linkedValidator to the linkedValidator collection.
	 * 
	 * @param linkedValidatorElement
	 *            Element to add.
	 */
	public void addLinkedValidator(CrossValidatorDescription linkedValidatorElement) {
		this.getLinkedValidator().add(linkedValidatorElement);
	}

	/**
	 * Remove a linkedValidator to the linkedValidator collection.
	 * 
	 * @param linkedValidatorElement
	 *            Element to remove
	 */
	public void removeLinkedValidator(CrossValidatorDescription linkedValidatorElement) {
		this.getLinkedValidator().remove(linkedValidatorElement);
	}

	/**
	 * Return engineVersion.
	 * 
	 * @return engineVersion
	 */
	public String getEngineVersion() {
		return engineVersion;
	}

	/**
	 * Set a value to attribute engineVersion.
	 * 
	 * @param engineVersion
	 *            .
	 */
	public void setEngineVersion(String engineVersion) {
		this.engineVersion = engineVersion;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "GazelleCrossValidator", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public String getAssertionManagerUrl() {
		return assertionManagerUrl;
	}

	public void setAssertionManagerUrl(String assertionManagerUrl) {
		this.assertionManagerUrl = assertionManagerUrl;
	}

}